Attribute VB_Name = "ActionpadHelper"
Option Explicit
Private locAvailableActionpads As Scripting.Dictionary

Public Sub setDefaultActionpads(bLbsActive As Boolean, Optional ByVal bPublishable As Boolean = False)
On Error GoTo ErrorHandler

    Dim oClass As LDE.Class
    Dim bShouldExist As Boolean
    Dim oFiles As Scripting.Dictionary
    
    'get avalible actionpad files
    Set oFiles = ActionpadHelper.getAvailableActionpads
    
    'set inspector actionpads
    For Each oClass In ThisApplication.Database.Classes
        bShouldExist = oFiles.Exists(oClass.Name)
        Call ActionpadHelper.setDefaultActionpad(oClass.Name, bLbsActive, bShouldExist, bPublishable)
    Next oClass
    
    'set main actionpad
    Call ActionpadHelper.setDefaultActionpad("index", bLbsActive, True, bPublishable)

Exit Sub

ErrorHandler:
    Call LC_UI.ShowError("ActionpadHelper.setDefaultActionpads")
End Sub

Public Sub setDefaultActionpad(ByVal sClass As String, sLbs As Boolean, bShouldExist As Boolean, bPublishable As Boolean, Optional ByVal lVisible As Long = 1)
    On Error GoTo ErrorHandler
    Dim oSettings As LDE.Settings
    Dim sClassGUID As String
    Dim sUrl As String
    Dim sUrlBase As String
    Dim sUrlSuffix As String
    
    'used to set lbs.html as actionpad if Lime Bootsrap is used
    If sLbs = True Then
        sUrlBase = ThisApplication.WebFolder + "lbs.html"
        sUrlSuffix = IIf(bPublishable, "", "?ap=" + sClass)
        sUrl = IIf(bShouldExist, sUrlBase + sUrlSuffix, "")
        lVisible = IIf(VBA.Len(sUrl) > 0, 1, 0)
    Else
        sUrl = ThisApplication.WebFolder + sClass + ".html"
    End If
        
    'index gets special treetment as it is not reloaded frequently and handle is available
    If sClass = "index" Then
        ThisApplication.WebBar.url = sUrl
    'normal inspector AP
    Else
        'find class GUID
        sClassGUID = Database.Classes(sClass).GUID
        'find inspector settings
        Set oSettings = ThisApplication.Database.Settings.Item("Inspectors")
        'check if inspector of the chosen class exists
        If oSettings.Exists(sClassGUID) Then
            'write url and visible property
            Call oSettings.Item(sClassGUID + "\WebBar").Write("URL", sUrl)
            Call oSettings.Item(sClassGUID + "\WebBar").Write("Visible", lVisible)
        End If
    End If
    Exit Sub
    
ErrorHandler:
    Call LC_UI.ShowError("myModule.setActionpad")
End Sub

'helper function to list all available actionpads
Public Function getAvailableActionpads() As Scripting.Dictionary
On Error GoTo ErrorHandler
    
    Dim sFileName As String
    Dim sClassName As String
    Dim oFiles As New Scripting.Dictionary
    
    If (locAvailableActionpads Is Nothing) Then
    
        sFileName = Dir(ThisApplication.WebFolder + "\*.html")
        Do While Len(sFileName) > 0
            sClassName = VBA.Left(sFileName, VBA.Len(sFileName) - 5)
            'dont add the aplication entrypoint
            If sClassName <> "lbs" Then
                Call oFiles.Add(sClassName, sClassName)
            End If
            sFileName = Dir
        Loop
        
        Set locAvailableActionpads = oFiles
    End If
        
    Set getAvailableActionpads = locAvailableActionpads
    
Exit Function

ErrorHandler:
    Call LC_UI.ShowError("lbsHelper.getAvailableActionpads")
End Function
